define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	// 引入jedate js css
	require("css!$UI/system/components/justep/jedate/jedate").load();
	var jeDate = require("$UI/system/components/justep/jedate/jedate");

	var Model = function() {
		this.callParent();
		this.state = "1";
	};

	Model.prototype.saveCommit = function(event) {
		if (this.state == "0") {
			// 调用saveData,不弹出提示
			this.state = "1";
		} else {
			justep.Util.hint("保存成功！", {
				type : 'success',
				parent : this.getRootNode()
			});
		}
	};

	Model.prototype.grid3RowClick = function(event) {
		var data = this.comp("mainData");
		var id = event.row.getID();
		data.to(id);
		// 获取选中行大会项目选择框值
		var dh = event.row.val("fXMXX_DHQYXM");
		// 根据值来显示大会信息:1(是):显示;0(否):不显示
		if (dh == 1) {
			$(".dhxx-show").show();
		} else {
			$(".dhxx-show").hide();
		}

		var tabs = this.comp('tabs');
		tabs.setActiveTab('nav-detail');
	};

	Model.prototype.button2Click = function(event) {
		var data = this.comp("mainData");
		var sts = data.deleteData();
		if (sts) {
			var tabs = this.comp('tabs');
			tabs.setActiveTab('nav-list');
		}
	};

	Model.prototype.addBtnClick = function() {
		var data = this.comp("mainData");
		data.newData();
		// 新增-隐藏大会信息
		$(".dhxx-show").hide();
		var tabs = this.comp('tabs');
		tabs.setActiveTab('nav-detail');
	};

	// 所属行业对话框 mengjie 20191122
	Model.prototype.fXMXX_SZXYClick = function(event) {
		this.comp("sshyDialog").open();
	};

	// 设置合作方式数据初始化参数 mengjie 20191122
	Model.prototype.hzfsRefreshCreateParam = function(event) {
		var mapParam = new biz.Request.MapParam();
		mapParam.put("djlb", "hzfs");
		event.param.setMap("variables", mapParam);
	};
	// 设置签约形式数据初始化参数 mengjie 20191122
	Model.prototype.qyxsRefreshCreateParam = function(event) {
		var mapParam = new biz.Request.MapParam();
		mapParam.put("djlb", "qyxs");
		event.param.setMap("variables", mapParam);
	};

	// 甲方企业对话框 mengjie 20191122
	Model.prototype.fXMXX_JFFocus = function(event) {
		this.comp("hzqyDialog").open();
	};

	// 设置隶属关系数据初始化参数 mengjie 20191122
	Model.prototype.qylbRefreshCreateParam = function(event) {
		var mapParam = new biz.Request.MapParam();
		mapParam.put("djlb", "qylb");
		event.param.setMap("variables", mapParam);
	};

	// 大会行业分类对话框 mengjie 20191128
	Model.prototype.fXMXX_XYFLFocus = function(event) {
		this.comp("dh_hyfl").open();
	};

	// 项目状态数据集设置初始化参数 mengjie 20191128
	Model.prototype.xmztRefreshCreateParam = function(event) {
		var mapParam = new biz.Request.MapParam();
		mapParam.put("djlb", "xmzt");
		event.param.setMap("variables", mapParam);
	};

	// 所属行业数据集初始化参数 mengjie 2019-12-23
	Model.prototype.sshyRefreshCreateParam = function(event) {
		var mapParam = new biz.Request.MapParam();
		mapParam.put("djlb", "sshy");
		event.param.setMap("variables", mapParam);
	};

	// 大会签约年份数据集初始化参数 mengjie 2019-12-23
	Model.prototype.dhqynfRefreshCreateParam = function(event) {
		var mapParam = new biz.Request.MapParam();
		mapParam.put("djlb", "qynf");
		event.param.setMap("variables", mapParam);
	};

	Model.prototype.modelLoad = function(event) {
		var me = this;
		// 为签约日期 、计划开始日、计划完成日期绑定jeDate
		$(".de").each(function() {
			jeDate(this, {
				theme : {
					bgcolor : "#00A1CB",
					color : "#ffffff",
					pnColor : "#00CCFF"
				},
				format : "YYYY-MM",
				donefun : function(obj) {
					// 获取当前input对象
					var val = obj.val;
					me.comp("mainData").setValue(valName, val);
				}
			});
		});
		// 大会签约年份
		jeDate(this.getElementByXid("fXMXX_DHQYNF"), {
			theme : {
				bgcolor : "#00A1CB",
				color : "#ffffff",
				pnColor : "#00CCFF"
			},
			format : "YYYY",
			donefun : function(obj) {
				// 获取当前input对象
				var val = obj.val;
				me.comp("mainData").setValue("fXMXX_DHQYNF", val);
			}
		});

	};

	// 大会项目值变化 mengjie 20191128
	Model.prototype.fXMXX_DHQYXMChange = function(event) {
		var value = this.comp("fXMXX_DHQYXM").val();
		if (value == 1) {
			// 大会项目选择是:显示大会信息(默认不显示)
			$(".dhxx-show").show();
		} else {
			// /大会项目选择否:隐藏大会信息
			$(".dhxx-show").hide();
		}
	};

	// 单元格渲染
	Model.prototype.listDataCellRender = function(event) {

		if ((event.colName == "fXMXX_SFZLXXXCY"
				|| event.colName == "fXMXX_SFRK"
				|| event.colName == "fXMXX_SFLBXM"
				|| event.colName == "fXMXX_SFZZ" || event.colName == "fXMXX_DHQYXM")
				&& event.colVal != "") {
			var value = event.colVal == 1 ? "是" : "否";
			// event.html = "<div>" + value + "</div>";
			event.html = value;
		}
		// 显示按钮 mengjie 2019-12-16
		if (event.colName == "button") {
			// 月报期间是否开启
			var ybqj = this.comp("ybqj").count();
			if (ybqj != 1) {
				event.html = "当前时间不能上报";
			} else {
				var xmjzID = event.row.ref("fXMXX_XMJZID").get();
				// 上报状态
				var sbzt = event.row.ref("fXMXX_SBBZ").get();
				// 项目状态
				var xmzt = event.row.ref("fXMXX_XMZT").get();

				var sbztLable = sbzt == '0' ? "未上报" : "已上报";
				// 封装参数 项目进展ID,选中行ID
				var json = {
					xmjzID : xmjzID,
					rowID : event.rowID,
					xmzt : xmzt
				};
				event.html = "<button class='btn btn-primary btn-ext'onclick='justep.Util.getModel(this).report("
						+ JSON.stringify(json)
						+ ")'><spanclass='icon-search'>"
						+ sbztLable + "</span></button>";
			}

		}

	};

	// 上报操作 mengjie 2019-12-16
	Model.prototype.report = function(data) {
		// var ybqj = this.comp("ybqj");
		// ybqj.refreshData();
		// if (ybqj.count() != 1) {
		// alert("当前时间不能填报");
		// // 刷新主data
		// this.comp("mainData").refreshData();
		// return;
		// // throw justep.Error.create("当前时间不能填报");
		// }

		var sjdw = this.comp("sjdw");
		if (sjdw.count() != 1) {
			alert("本单位在组织体系没有定义,不能上报!请联系系统管理员!");
			return;
		}
		var sjdwID = sjdw.getValue("SFID");
		data.sjdwID = sjdwID;
		// 打开对话框
		this.comp("report").open({
			data : data
		});
		// 停止事件的传播，否则还会触发RowClick事件
		event.stopPropagation();
	};

	// 上报接收参数 mengjie 2019-12-20
	Model.prototype.reportReceive = function(event) {
		// 接收参数
		var data = event.data;
		var xmjzID = data.xmjzID;
		var xmID = data.rowID;
		// 保存数据
		var mainData = this.comp("mainData");
		// 需要保存的行
		var row = mainData.getRowByID(xmID);
		mainData.setValue("fXMXX_XMJZID", xmjzID, row);
		// 上报状态
		mainData.setValue("fXMXX_SBBZ", "1", row);
		// 更新时间
		mainData.setValue("fXMXX_GXRQ", new Date(), row);
		this.state = "0";// 调用saveData,不弹出提示
		mainData.saveData({
			"onError" : function(event) {
				this.state = "1";// 保存失败恢复state的值
			},
			"onSuccess" : function(event) {
				event.source.refreshData();
			},
			"ignoreInvalid":true
		});
	};

	// 显示、隐藏搜索框 mengjie 2019-12-20
	Model.prototype.checkboxChange = function(event) {
		if (event.checked) {
			$(this.getElementByXid("searchArea")).slideDown();
			$(this.getElementByXid("searchBtn")).slideDown();
		}

		else {
			$(this.getElementByXid("searchArea")).slideUp();
			$(this.getElementByXid("searchBtn")).slideUp();
		}

	};

	// 查询动作 mengjie 2019-12-23
	Model.prototype.searchBtnClick = function(event) {

		// 获取条件值
		var xmmc = this.comp("XMMC").get("value");// 项目名称
		var sshy = this.comp("SSHY").get("value");// 所属行业
		var ssjg = this.comp("SSJG").get("value");// 所属机构
		var sbzt = this.comp("SBZT").get("value");// 上报状态
		var zlxxcy = this.comp("ZLXXCY").get("value");// 是否战略性新兴产业
		var xmzt = this.comp("XMZT").get("value");// 项目状态
		var sfrk = this.comp("SFRK").get("value");// 是否入库
		var sfdhxm = this.comp("SFDHXM").get("value");// 是否大会项目
		var qynf = this.comp("QYNF").get("value");// 签约年份
		var hzfs = this.comp("HZFS").get("value");// 合作方式
		var qyxs = this.comp("QYXS").get("value");// 签约形式
		var jf = this.comp("JF").get("value");// 甲方
		var tzgmls = this.comp("TZGMLS").get("value");// 投资规模(亿元)-最小
		var tzgmll = this.comp("TZGMLL").get("value");// 投资规模(亿元)-最大
		var ljwcls = this.comp("LJWCLS").get("value");// 截止目前累计完成额(万元)-最小
		var ljwcll = this.comp("LJWCLL").get("value");// 截止目前累计完成额(万元)-最大

		var data = this.comp("mainData");
		var filterText = "1=1";
		if (xmmc) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_XMMC LIKE '%" + xmmc
					+ "%'";
		}
		if (sshy) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_SZXY = '" + sshy
					+ "'";
		}
		// TODO:设置市查询-所属机构固定值.后期若增加县区填报,所属机构为空:查询
		if (ssjg) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_SZZZFID like'%"
					+ this.getContext().getCurrentOgnID() + "%'";
		}
		if (sbzt) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_SBBZ = '" + sbzt
					+ "'";
		}
		if (zlxxcy) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_SFZLXXXCY = '"
					+ zlxxcy + "'";
		}
		if (xmzt) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_XMZT = '" + xmzt
					+ "'";
		}
		if (sfrk) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_SFRK = '" + sfrk
					+ "'";
		}
		if (sfdhxm) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_DHQYXM = '" + sfdhxm
					+ "'";
		}
		if (qynf) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_DHQYNF = '" + qynf
					+ "'";
		}
		if (hzfs) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_HZFS = '" + hzfs
					+ "'";
		}
		if (qyxs) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_QYXS = '" + qyxs
					+ "'";
		}
		if (jf) {
			filterText = filterText + "and YQHZ_HZQY.fHZQY_QYMC LIKE '%" + jf
					+ "%'";
		}
		if (tzgmls) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_TZGM > '" + tzgmls
					+ "'";
		}
		if (tzgmll) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_TZGM < '" + tzgmll
					+ "'";
		}
		if (ljwcls) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_MQLJWCE > '"
					+ ljwcls + "'";
		}
		if (ljwcll) {
			filterText = filterText + "and YQHZ_XMXX.fXMXX_MQLJWCE < '"
					+ ljwcll + "'";
		}

		data.filters.clear();// 清除所有查询条件
		data.setFilter("filter", filterText);
		data.refreshData();
	};

	// 设置mainData初始化查询条件
	Model.prototype.modelModelConstruct = function(event) {
		var mainData = this.comp("mainData");
		mainData.setFilter("org", "YQHZ_XMXX.fXMXX_SZZZFID like '%"
				+ this.getContext().getCurrentOgnID() + "%'");
	};

	// 查看按钮 mengjie 20200102
	Model.prototype.lookbtnClick = function(event) {
		this.comp("look").open({
			data : this.comp("mainData").getRowID()
		});

	};

	// 手机、电话规则校验 mengjie 20200103
	Model.prototype.mainDataValueChange = function(event) {
		// 手机号
		if (event.col == "fXMXX_SJHM" && event.newValue != "") {
			var reg = /^1[0-9]{10}$/;// 正则表达式:1开头，后边10位全是数字
			var flag = reg.test(event.newValue);
			if (!flag) {
				alert("手机号格式不对,要求11位");
				event.newValue = null;
			}
		}
		// 固定电话 全至少6位
		if (event.col == "fXMXX_GDDH" && event.newValue != "") {
			var rg = /^(\d{3,4}-)\d{6,8}$/;
			var flagx = rg.test(event.newValue);
			if (!flagx) {
				alert("固定电话格式不对,格式要求:区号-电话号码");
				event.newValue = null;
			}
			;
		}
	};

	// 保存前校验 mengjie 20200102
	Model.prototype.mainDataBeforeSave = function(event) {
		var fxmxx_sjhm = event.source.getValue("fXMXX_SJHM");
		var fxmxx_gddh = event.source.getValue("fXMXX_GDDH");
		if ((fxmxx_sjhm == undefined || fxmxx_sjhm == "")
				&& (fxmxx_gddh == undefined || fxmxx_gddh == "")) {
			alert("手机号码、固定电话必须填写一个!");
			event.cancel = true;// 中断保存
			return;
		}

		// 上级组织
		var sjdw = this.comp("sjdw");
		if (sjdw.count() != 1) {
			throw justep.Error.create("上级单位不存在,请联系系统管理员!");
		}
		event.source.setValue("fXMXX_SJZZ", sjdw.getValue("SNAME"));
		event.source.setValue("fXMXX_SJZZFID", sjdw.getValue("SFID"));
	};

	// 无进展批量上报 mengjie 20200203
	Model.prototype.batchReportBtnClick = function(event) {
		// 弹出询问对话框
		var self = this;
		justep.Util.confirm("确定要进行无进展批量操作吗？", function() {
			var mainData = self.comp("mainData");
			// 执行action
			var params = new biz.Request.ActionParam();
			var ybqj = self.comp("ybqj");// 进展年月
			params.setString("year", ybqj.getValue("fYBQJ_ND"));
			params.setString("month", ybqj.getValue("fYBQJ_YD"));
			biz.Request.sendBizRequest({
				"context" : self.getContext(),
				"action" : "batchReportAction",
				"parameters" : params,
				"callback" : function(data) {
					data.ignoreError = false;
					if (data.state) {
						// 刷新
						mainData.refreshData();
						justep.Util.hint("无进展上报成功!", {
							type : 'success',
							parent : self.getRootNode()
						});
					}
				}
			});
		});

	};

	// 删除前验证 入库、已上报都不能删除 mengjie
	Model.prototype.mainDataBeforeDelete = function(event) {
		var fXMXX_SFRK = event.source.val("fXMXX_SFRK");
		var fXMXX_SBBZ = event.source.val("fXMXX_SBBZ");
		if (fXMXX_SFRK == '1' || fXMXX_SBBZ == '1') {
			alert("已入库、已上报项目不能删除");
			event.cancel = true;// 设置方法不往下执行
		}
	};

	Model.prototype.tabsSelect = function(event) {
		var listXid = event.tab.select().find("a").attr("xid");
		if (listXid == "tabItem1") {// 判断是否是列表页签
			$(window).resize();
		}
	};

	Model.prototype.butt = function(event){
		var data = this.comp("mainData");
		var row = data.getCurrentRow();
		var s =data.getRowID();
		debugger;
	};

	return Model;
});